#include <cstdio>
#include <fstream>
#include <algorithm>

using namespace std;

const char *infile="ridge.dat";
const char *outfile="ridge.sol";

const int maxN=100000;
const int logN=17;

typedef long long LLong;

int h[logN][maxN];
int view[maxN];
int maxlv[maxN+1];
int n;

inline void RMQPrecalc() {
     int i,d,lv,dd2;
     maxlv[0]=maxlv[1]=0;
     for(lv=1;(1<<lv)<n;lv++) {
          for(i=0,d=(1<<lv),dd2=d/2;i+d<=n;i++)
               h[lv][i]=max(h[lv-1][i],h[lv-1][i+dd2]);
          for(i=(1<<lv),d=min(n,1<<(lv+1));i<=d;i++)
               maxlv[i]=lv;
     }
}

inline int RMQQuery(int a,int b) {
     if(a>b)return -1;
     int lv=maxlv[b-a+1];
     return max(h[lv][a],h[lv][b+1-(1<<lv)]);
}

int main() {
     int t,i;
     int beg,end,mid;
     LLong res,cur;
     FILE *ifs=fopen(infile,"r");
     ofstream ofs(outfile);

     fscanf(ifs,"%d%d",&n,&t);
     for(i=0;i<n;i++)fscanf(ifs,"%d",&h[0][i]);
     
     RMQPrecalc();
     for(i=0;i<n;i++) {
          beg=0,end=i;
          while(beg!=end) {
               mid=(beg+end)/2;
               if(h[0][i]>RMQQuery(mid,i-1))end=mid;
               else beg=mid+1;
          }
          view[i]=beg;
          beg=i,end=n-1;
          while(beg!=end) {
               mid=(beg+end+1)/2;
               if(h[0][i]>RMQQuery(i+1,mid))beg=mid;
               else end=mid-1;
          }
          view[i]=end-view[i];
     }

     for(i=0,res=-1,cur=0;i<n;i++) {
          cur+=view[i];
          if(i>=t)cur-=view[i-t];
          if(res<cur)res=cur;
     }
     ofs<<res<<endl;

     fclose(ifs);
     return 0;
}
